import { _decorator, Component, Node, Vec2, Touch, v2, PhysicsSystem2D, EPhysics2DDrawFlags } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('main')
export class main extends Component {
  @property({
    type: Node
  })
  root!: Node

  touchInitialPos: Vec2;


  start() {
    PhysicsSystem2D.instance.debugDrawFlags = EPhysics2DDrawFlags.Shape;
    const canvas = this.node;
    canvas.on(Node.EventType.TOUCH_START, this.touchStart, this);
    canvas.on(Node.EventType.TOUCH_MOVE, this.touchMove, this);
  }

  private touchStart(event: Touch) {
    this.touchInitialPos = event.getStartLocation();
  }

  private touchMove(event: Touch) {
    const currPos = v2();
    event.getLocation(currPos).subtract(this.touchInitialPos)
    this.root.setPosition(currPos.x, currPos.y);
  }

  update(deltaTime: number) {
      
  }

}

